osg::ShaderAttribute Class Reference

`#include <ShaderAttribute>`

Inheritance diagram for osg::ShaderAttribute:

## Public Member Functions

| ShaderAttribute ()
| ShaderAttribute (const ShaderAttribute &sa, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual osg::Object * | cloneType () const
virtual osg::Object * | clone (const osg::CopyOp &copyop) const
virtual bool | isSameKindAs (const osg::Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual int | compare (const StateAttribute &sa) const
void | setType (Type type)
virtual Type | getType () const
unsigned int | addShader (Shader *shader)
void | removeShader (unsigned int i)
unsigned int | getNumShaders () const
Shader * | getShader (unsigned int i)
const Shader * | getShader (unsigned int i) const
unsigned int | addUniform (Uniform *uniform)
void | removeUniform (unsigned int i)
unsigned int | getNumUniforms () const
Uniform * | getUniform (unsigned int i)
const Uniform * | getUniform (unsigned int i) const
virtual bool | getModeUsage (StateAttribute::ModeUsage &usage) const
virtual void | apply (State &state) const
virtual void | compileGLObjects (State &state) const
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (State *state=0) const
Public Member Functions inherited from osg::StateAttribute
| StateAttribute ()
| StateAttribute (const StateAttribute &sa, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Texture * | asTexture ()
virtual const Texture * | asTexture () const
virtual unsigned int | getMember () const
TypeMemberPair | getTypeMemberPair () const
virtual bool | isTextureAttribute () const
bool | operator< (const StateAttribute &rhs) const
bool | operator== (const StateAttribute &rhs) const
bool | operator!= (const StateAttribute &rhs) const
const ParentList & | getParents () const
StateSet * | getParent (unsigned int i)
const StateSet * | getParent (unsigned int i) const
unsigned int | getNumParents () const
void | setShaderComponent (ShaderComponent *sc)
ShaderComponent * | getShaderComponent ()
const ShaderComponent * | getShaderComponent () const
virtual bool | checkValidityOfAssociatedModes (osg::State &) const
void | setUpdateCallback (StateAttributeCallback *uc)
StateAttributeCallback * | getUpdateCallback ()
const StateAttributeCallback * | getUpdateCallback () const
void | setEventCallback (StateAttributeCallback *ec)
StateAttributeCallback * | getEventCallback ()
const StateAttributeCallback * | getEventCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::vector< osg::ref_ptr< osg::Uniform > > | Uniforms

## Protected Member Functions

virtual | ~ShaderAttribute ()
Protected Member Functions inherited from osg::StateAttribute
virtual | ~StateAttribute ()
void | addParent (osg::StateSet *object)
void | removeParent (osg::StateSet *object)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

Type | _type
Uniforms | _uniforms
Protected Attributes inherited from osg::StateAttribute
ParentList | _parents
ref_ptr< ShaderComponent > | _shaderComponent
ref_ptr< StateAttributeCallback > | _updateCallback
ref_ptr< StateAttributeCallback > | _eventCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::StateAttribute
enum | Values { OFF = 0x0 , ON = 0x1 , OVERRIDE = 0x2 , PROTECTED = 0x4 , INHERIT = 0x8 }

enum

Type {
TEXTURE , POLYGONMODE , POLYGONOFFSET , MATERIAL ,
ALPHAFUNC , ANTIALIAS , COLORTABLE , CULLFACE ,
FOG , FRONTFACE , LIGHT , POINT ,
LINEWIDTH , LINESTIPPLE , POLYGONSTIPPLE , SHADEMODEL ,
TEXENV , TEXENVFILTER , TEXGEN , TEXMAT ,
LIGHTMODEL , BLENDFUNC , BLENDEQUATION , LOGICOP ,
STENCIL , COLORMASK , DEPTH , VIEWPORT ,
SCISSOR , BLENDCOLOR , MULTISAMPLE , CLIPPLANE ,
COLORMATRIX , VERTEXPROGRAM , FRAGMENTPROGRAM , POINTSPRITE ,
PROGRAM , CLAMPCOLOR , HINT , SAMPLEMASKI ,
PRIMITIVERESTARTINDEX , CLIPCONTROL , VALIDATOR , VIEWMATRIXEXTRACTOR ,
OSGNV_PARAMETER_BLOCK , OSGNVEXT_TEXTURE_SHADER , OSGNVEXT_VERTEX_PROGRAM , OSGNVEXT_REGISTER_COMBINERS ,
OSGNVCG_PROGRAM , OSGNVSLANG_PROGRAM , OSGNVPARSE_PROGRAM_PARSER , UNIFORMBUFFERBINDING ,
TRANSFORMFEEDBACKBUFFERBINDING , ATOMICCOUNTERBUFFERBINDING , PATCH_PARAMETER , FRAME_BUFFER_OBJECT ,
VERTEX_ATTRIB_DIVISOR , SHADERSTORAGEBUFFERBINDING , INDIRECTDRAWBUFFERBINDING , VIEWPORTINDEXED ,
DEPTHRANGEINDEXED , SCISSORINDEXED , BINDIMAGETEXTURE , SAMPLER ,
CAPABILITY = 100
}

typedef GLenum | GLMode
typedef unsigned int | GLModeValue
typedef unsigned int | OverrideValue
typedef std::pair< Type, unsigned int > | TypeMemberPair
typedef std::vector< StateSet * > | ParentList
typedef osg::StateAttributeCallback | Callback
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Member Typedef Documentation

## Uniforms

typedef std::vector< osg::ref_ptr<osg::Uniform> > osg::ShaderAttribute::Uniforms

protected

## Constructor & Destructor Documentation

## ShaderAttribute() [1/2]

osg::ShaderAttribute::ShaderAttribute | ( |  | ) |

Referenced by clone(), isSameKindAs(), and ShaderAttribute().

## ShaderAttribute() [2/2]

osg::ShaderAttribute::ShaderAttribute | ( | const ShaderAttribute & | sa,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References ShaderAttribute(), and osg::CopyOp::SHALLOW_COPY.

## ~ShaderAttribute()

virtual osg::ShaderAttribute::~ShaderAttribute | ( |  | ) |

protected virtual

## Member Function Documentation

## addShader()

unsigned int osg::ShaderAttribute::addShader | ( | Shader * | shader | ) |

inline

References osg::StateAttribute::_shaderComponent.

## addUniform()

unsigned int osg::ShaderAttribute::addUniform | ( | Uniform * | uniform | ) |

## apply()

virtual void osg::ShaderAttribute::apply | ( | State & |  | ) | const

virtual

apply the OpenGL state attributes. The render info for the current OpenGL context is passed in to allow the StateAttribute to obtain details on the the current context and state.

Reimplemented from osg::StateAttribute.

## className()

virtual const char * osg::ShaderAttribute::className | ( |  | ) | const

inline virtual

Return the name of the attribute's class type.

Reimplemented from osg::StateAttribute.

## clone()

virtual osg::Object * osg::ShaderAttribute::clone | ( | const osg::CopyOp & |  | ) | const

inline virtual

Clone an attribute, with Object* return type. Must be defined by derived classes.

Implements osg::StateAttribute.

References ShaderAttribute().

## cloneType()

virtual osg::Object * osg::ShaderAttribute::cloneType | ( |  | ) | const

virtual

Clone the type of an attribute, with Object* return type. Must be defined by derived classes.

Implements osg::StateAttribute.

## compare()

virtual int osg::ShaderAttribute::compare | ( | const StateAttribute & | sa | ) | const

virtual

return -1 if *this < *rhs, 0 if *this==*rhs, 1 if *this>*rhs.

Implements osg::StateAttribute.

References osg::StateAttribute::StateAttribute().

## compileGLObjects()

virtual void osg::ShaderAttribute::compileGLObjects | ( | State & |  | ) | const

virtual

Default to nothing to compile - all state is applied immediately.

Reimplemented from osg::StateAttribute.

## getModeUsage()

virtual bool osg::ShaderAttribute::getModeUsage | ( | StateAttribute::ModeUsage & |  | ) | const

virtual

Return the modes associated with this StateAttribute.

Reimplemented from osg::StateAttribute.

## getNumShaders()

unsigned int osg::ShaderAttribute::getNumShaders | ( |  | ) | const

inline

References osg::StateAttribute::_shaderComponent.

## getNumUniforms()

unsigned int osg::ShaderAttribute::getNumUniforms | ( |  | ) | const

inline

References _uniforms.

## getShader() [1/2]

Shader * osg::ShaderAttribute::getShader | ( | unsigned int | i | ) |

inline

References osg::StateAttribute::_shaderComponent.

## getShader() [2/2]

const Shader * osg::ShaderAttribute::getShader | ( | unsigned int | i | ) | const

inline

References osg::StateAttribute::_shaderComponent.

## getType()

virtual Type osg::ShaderAttribute::getType | ( |  | ) | const

inline virtual

Return the Type identifier of the attribute's class type.

Implements osg::StateAttribute.

References _type.

## getUniform() [1/2]

Uniform * osg::ShaderAttribute::getUniform | ( | unsigned int | i | ) |

inline

References _uniforms.

## getUniform() [2/2]

const Uniform * osg::ShaderAttribute::getUniform | ( | unsigned int | i | ) | const

inline

References _uniforms.

## isSameKindAs()

virtual bool osg::ShaderAttribute::isSameKindAs | ( | const osg::Object * | obj | ) | const

inline virtual

Return true if this and obj are of the same kind of object.

Reimplemented from osg::StateAttribute.

References NULL, and ShaderAttribute().

## libraryName()

virtual const char * osg::ShaderAttribute::libraryName | ( |  | ) | const

inline virtual

Return the name of the attribute's library.

Reimplemented from osg::StateAttribute.

## releaseGLObjects()

virtual void osg::ShaderAttribute::releaseGLObjects | ( | State * | = 0 | ) | const

virtual

Release OpenGL objects in specified graphics context if State object is passed, otherwise release OpenGL objects for all graphics context if State object pointer NULL.

Reimplemented from osg::StateAttribute.

## removeShader()

void osg::ShaderAttribute::removeShader | ( | unsigned int | i | ) |

inline

References osg::StateAttribute::_shaderComponent.

## removeUniform()

void osg::ShaderAttribute::removeUniform | ( | unsigned int | i | ) |

## resizeGLObjectBuffers()

virtual void osg::ShaderAttribute::resizeGLObjectBuffers | ( | unsigned int |  | ) |

virtual

Resize any per context GLObject buffers to specified size.

Reimplemented from osg::StateAttribute.

## setType()

void osg::ShaderAttribute::setType | ( | Type | type | ) |

## Member Data Documentation

## _type

Type osg::ShaderAttribute::_type

protected

Referenced by getType().

## _uniforms

Uniforms osg::ShaderAttribute::_uniforms

protected

Referenced by getNumUniforms(), getUniform(), and getUniform().

The documentation for this class was generated from the following file:

- ShaderAttribute